from typing import Optional

from bot_api.abc.dto_abc import DtoABC


class ServerDTO(DtoABC):

    def __init__(
            self,
            server_id: int,
            discord_id: int,
            name: str,
            member_count: int,
            icon_url: Optional[str]

    ):
        DtoABC.__init__(self)

        self._server_id = server_id
        self._discord_id = discord_id
        self._name = name
        self._member_count = member_count
        self._icon_url = icon_url
        
    @property
    def server_id(self) -> int:
        return self._server_id
    
    @property
    def discord_id(self) -> int:
        return self._discord_id
    
    @property
    def name(self) -> str:
        return self._name
    
    @property
    def member_count(self) -> int:
        return self._member_count

    @property
    def icon_url(self) -> Optional[str]:
        return self._icon_url

    def from_dict(self, values: dict):
        self._server_id = int(values['serverId'])
        self._discord_id = int(values['discordId'])
        self._name = values['name']
        self._icon_url = values['iconURL']

    def to_dict(self) -> dict:
        return {
            'serverId': self._server_id,
            'discordId': self._discord_id,
            'name': self._name,
            'memberCount': self._member_count,
            'iconURL': self._icon_url,
        }
